;;; CAD-CEE 2000
;;;  : 25.02.93
;;;   : 15.08.2001 ( ..)
;;;  ..
;;;       
;;;  : (heat dap dt dor s tt lstn lstn1 ip a1 mb pr)
;;; :      dap -  ;
;;;           dt -   ;
;;;           dor -    ;
;;;           s -   ;
;;;           tt -  ;
;;;           lstn -      (  );
;;;           lstn1 -    ;
;;;           ip -  ;
;;;           a1 -  ;
;;;           mb -  ;
;;;           pr -   ("1" -  , "2" -  , "3" -   )

(defun heat (dap dt   dor  s	tt   lstn lstn1 ip   a1   mb	 pr   /	   fn
		 lst  lstd md	p1   p2	  p3   p4   co	 flag a3   a4
		 a5   htt  no	  n    r    r1	 c1   z1   z2
		 zz1  zz3  zz2	zz4  obj1 obj2 ed   noold     nonew
		 nn   m	   old	new  t1	  txt  a6
	    )

;;;   
  (defun osn ()
    (command "_'layer" "_s" "" "")
  ) ;_  defun
  (defun axs2 ()
    (command "_'layer" "_s" " 2" "")
  ) ;_  defun

;;;  
  (setq	a3  (/ pi 2.0)
	a4  (+ a3 pi)
	a5  (/ pi 3.0)
	htt (* tt (sin a5))
  ) ;_  setq
  (setq	no (last lstn1)
	n  (length lstn1)
	r  (1- n)
	r1 (polar ip (+ a1 a4) (* htt (1- n) mb))
	c1 (polar ip a1 (* (/ dap 2.0) mb))
	z1 (polar c1 (+ a1 a3) (* (/ dap 2.0) mb))
	z2 (polar ip (angle z1 ip) (distance z1 ip))
  ) ;_  setq

;;;     
  (axs2)
  (command "_LINE" ip c1 "")
  (setq label (entlast))
  (setq sset (ssadd (entlast)))
  (command "_ARRAY" "_l" "" "_p" ip "4" "360.0" "y")
  
  (if (<= dap 400)
    (command "_ZOOM" "_w" z1 z2)
    (progn
      (setq zz1	(polar ip a1 (* (/ tt 2.0) (apply 'max lstn1) mb))
	    zz3	(polar zz1 (+ a1 a3) (* htt (length lstn1) mb))
	    zz2	(polar ip (angle zz3 ip) (distance zz3 ip))
	    zz4	(polar ip (+ a1 pi) (* (/ tt 2.0) (apply 'max lstn1) mb))
      ) ;_  setq
      (command "_ZOOM" "_w" zz2 zz1)
    ) ;_  progn
  ) ;_  if
;;;    
  (repeat (- (* 2 n) 1)
    (setq co (polar r1 (+ a1 pi) (/ (* tt (1- no) mb) 2.0)))
    (repeat no
      (setq p1	 (polar co (+ a1 a5) (* (/ tt 2.0) mb))
	    p2	 (polar co (+ a1 (* a5 2.0)) (* (/ tt 2.0) mb))
	    p3	 (polar co (+ a1 (* a5 4.0)) (* (/ tt 2.0) mb))
	    p4	 (polar co (+ a1 (* a5 5.0)) (* (/ tt 2.0) mb))
	    obj1 (ssget p3)
	    obj2 (ssget p4)
      ) ;_  setq
      (if obj1
	(progn
	  (setq	ed (entget (ssname obj1 0))
		ed (subst (cons 11 p1) (assoc 11 ed) ed)
	  ) ;_  setq
	  (entmod ed)
	) ;_  progn
	(command "_LINE" p3 p1 "")	;  
      ) ;_  if
      (if obj2
	(progn
	  (setq	ed (entget (ssname obj2 0))
		ed (subst (cons 11 p2) (assoc 11 ed) ed)
	  ) ;_  setq
	  (entmod ed)
	) ;_  progn
	(command "_LINE" p4 p2 "")	;  
      ) ;_  if
      (setq co (polar co a1 (* tt mb)))
    ) ;_  repeat
    (setq r1 (polar r1 (+ a1 a3) (* htt mb))
	  r  (1- r)
	  no (nth (abs r) lstn1)
    ) ;_  setq
    (if	(and (> dap 400) (< r 0) (not flag))
      (progn
	(setq c1 (polar ip (+ a1 pi) (* (/ dap 2.0) mb)))
	(command "_ZOOM" "_w" zz4 zz3)
	(setq flag T)
      ) ;_  progn
    ) ;_  if
  ) ;_  repeat
  (if (> dap 400)
    (command "ZOOM" "w" z1 z2)
  ) ;_  if

;;;   
  (osn)
  (setq	r     (- n 2)
	noold 0
	no    (last lstn)
	nonew (nth r lstn)
	nn    0
  ) ;_  setq

;;;    
(if (/= pr "3")
  (repeat (- (* 2 n) 1)
    (setq r   (1- r)
	  m   1
	  r1  (polar r1 (+ a1 a4) (* htt mb))
	  co  (polar r1 (+ a1 pi) (/ (* tt (1- no) mb) 2.0))
	  old (abs (- no noold))
	  new (abs (- nonew no))
    ) ;_  setq
    (repeat no
      (if (or (= m 1)
	      (= (float m) (+ (/ no 2.0) 0.5))
	      (= m no)
	      (and (or (>= old 2) (>= new 2))
		   (or (<= m (1+ (/ old 2)))
		       (<= m (1+ (/ new 2)))
		       (>= m (- no (/ old 2)))
		       (>= m (- no (/ new 2)))
		   ) ;_  or
	      ) ;_  and
	  ) ;_  or
	(if (eq pr "1")			;  
	  (progn
	    (command "_CIRCLE" co (* (/ dt 2.0) mb))
	    (command "_CIRCLE" co (* (- (/ dt 2.0) s) mb))
	  ) ;_  progn
	  (command "_CIRCLE" co (* (/ dor 2.0) mb))
	) ;_  if
      ) ;_  if
      (setq co (polar co a1 (* tt mb))
	    m  (1+ m)
      ) ;_  setq
    ) ;_  repeat
    (setq noold	no
	  no	nonew
	  nonew	(nth (abs r) lstn)
    ) ;_  setq
    (if	(not nonew)
      (setq nonew 0)
    ) ;_  if
  ) ;_  repeat
) ;_  if

  (command "_ZOOM" "_a")
  (princ)
) ;_  defun
